package cn.iocoder.yudao.module.system.controller.admin.biz;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlydisinfectrecord.ElderlyDisinfectRecordPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlydisinfectrecord.ElderlyDisinfectRecordRespVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlydisinfectrecord.ElderlyDisinfectRecordSaveReqVO;
import cn.iocoder.yudao.module.system.service.biz.ElderlyDisinfectRecordService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 消毒记录")
@RestController
@RequestMapping("/elderly-disinfect-record")
@Validated
public class ElderlyDisinfectRecordController {

    @Resource
    private ElderlyDisinfectRecordService elderlyDisinfectRecordService;

    @PostMapping("/create")
    @Operation(summary = "创建消毒记录")
    public CommonResult<Long> create(@Valid @RequestBody ElderlyDisinfectRecordSaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(elderlyDisinfectRecordService.create(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "更新消毒记录")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody ElderlyDisinfectRecordSaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        elderlyDisinfectRecordService.update(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除消毒记录")
    @Parameter(name = "id", description = "编号", required = true)
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        elderlyDisinfectRecordService.delete(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得消毒记录详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<ElderlyDisinfectRecordRespVO> get(@RequestParam("id") Long id) {
        return success(elderlyDisinfectRecordService.get(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得消毒记录分页")
    @TenantIgnore
    public CommonResult<PageResult<ElderlyDisinfectRecordRespVO>> page(@Valid ElderlyDisinfectRecordPageReqVO pageReqVO) {
        if (pageReqVO.getTenantIds() == null) {
            pageReqVO.setTenantIds(new Long[]{TenantContextHolder.getTenantId()});
        }
        return success(elderlyDisinfectRecordService.getPage(pageReqVO));
    }
}
